<template>
	<div class="website-analyzer">
		<transition name="fade">
			<div class="analyzer" v-if="!scan_mode && active" v-on:click.self="$emit('closeanalyzerinfo')">
				<div class="scan-wave" v-if="animation == 'active'"></div>
			
				<div class="inner azure-gradient ">
					<div class="medium-font uppercase align-center bold green-color">{{ getLocale('analyze_website') }}</div>
					
					<div class="loader flex v-center space">
						<div class="current-energy lightestazure-color">
							<div class="flex space text">
								<div class="bold uppercase">{{ getLocale('energy') }}</div>
								<div class="bold uppercase">{{current_energy}}</div>
							</div>
							<div class="energy-bar">
								<div class="bar">
									<div class="dot lightestazure-border lightestazure-bkg" :style="{left: ((current_energy*100)/analyzer.max_energy)+'%'}"></div> 
									<div class="base lightestazure-bkg" :style="{width: ((current_energy*100)/analyzer.max_energy)+'%'}"></div>
								</div>
							</div>
						</div>
						
						<v-button
							v-if="!analysis"
							@clicked="startAnalysis" 
							:text="getLocale('analyze')" 
							color="lightestazure" 
							:disabled="animation == 'active' || current_energy < 10"
						/>
					</div>
					
					<div class="wave" :class="{active : animation != 'start', hide : animation == 'end'}">
						<div v-for="n in 20" class="bar" :style="{left: (28*(n-1))+'px'}"></div>
					</div>
					
					<div class="analysis" :class="{active : animation == 'end'}">
						<div class="flex space" v-if="analysis">
						
							<div class="graph-wrapper">
								<div class="graph">
									<svg xmlns="http://www.w3.org/2000/svg" width="100" height="100" viewBox="-50 -50 100 100">
										<defs>
											<radialGradient id="gradient" 
												:cx="(analysis.resources[3]+1) / ((analysis.resources[3]+1) + (analysis.resources[1]+1))" 
												:cy="(analysis.resources[0]+1) / ((analysis.resources[0]+1) + (analysis.resources[2]+1))" 
											>
												<stop offset="0%" stop-color="transparent" />
												<stop offset="100%" stop-color="white" />
											</radialGradient>
										</defs>
										
										<polygon :points="'0,-'+(analysis.resources[0]*5+1)+' '+(analysis.resources[1]*5+1)+',0 0,'+(analysis.resources[2]*5+1)+' -'+(analysis.resources[3]*5+1)+',0'" fill="white" />
										
										<circle r="45" fill="none" stroke="rgba(255,255,255,0.25)" stroke-width="0.5" />
										<circle r="30" fill="none" stroke="rgba(255,255,255,0.25)" stroke-width="0.5" />
										<circle r="15" fill="none" stroke="rgba(255,255,255,0.25)" stroke-width="0.5" />
									</svg>
									
									<div class="x-axis small-font align-center">
										<div class="labels">
											<div class="stat-label">
												<div class="text">{{getLocale('shards')}}</div>
											</div>
											
											<div class="stat-label">
												<div class="text">{{getLocale('chips')}}</div>
											</div>
										</div>
										
										<div class="bubbles small-font">
											<div class="bubble" :style="{
												bottom : ((50 + analysis.resources[1]*5)+1)+'%',
												top    : ((50 + analysis.resources[1]*5)+1)+'%'
											}">
												{{ analysis.resources[1] }}
											</div>
											<div class="bubble" :style="{
												bottom : ((50 + analysis.resources[3]*5)+1)+'%',
												top    : ((50 + analysis.resources[3]*5)+1)+'%'
											}">
												{{ analysis.resources[3] }}
											</div>
										</div>
									</div>
									
									<div class="y-axis small-font align-center">
										<div class="labels">
											<div class="stat-label">
												<div class="text">Bytes</div>
											</div>
											
											<div class="stat-label">
												<div class="text">{{getLocale('keys')}}</div>
											</div>
										</div>
										
										<div class="bubbles small-font">
											<div class="bubble" :style="{
												bottom : ((50 + analysis.resources[0]*5)+1)+'%',
												top    : ((50 + analysis.resources[0]*5)+1)+'%'
											}">
												{{ analysis.resources[0] }}
											</div>
											<div class="bubble" :style="{
												bottom : ((50 + analysis.resources[2]*5)+1)+'%',
												top    : ((50 + analysis.resources[2]*5)+1)+'%'
											}">
												{{ analysis.resources[2] }}
											</div>
										</div>
									</div>
								</div>
							</div>
							
							<div class="probes">
								<div v-if="!analysis.probed">
									<div 
										v-for="n in 3" 
										class="probe azure-border azure-gradient" 
										:class="{
											available : probes.length == n-1, 
											disabled : probes.length <= n-2, 
											probing : probing_this
										}" 
										v-on:click="sendProbe"
									>
										<div class="timer" v-if="probes.length > n-1">{{ parseTime(probes[n-1].end*1000 - current_time) }}</div>
										<div class="send">
											<span v-if="!probing_this">{{ parseTime(probe_timer*1000) }}<br>{{ getLocale('send') }}</span>
											<span v-else>{{ getLocale('already_probing') }}</span>
										</div>
										
										<svg width="100" height="100" viewbox="0 0 100 100" v-if="n <= probes.length">
											<circle cx="50" cy="50" r="43" stroke="#00C2FF" fill="none" stroke-width="5" stroke-dasharray="1 2"/>
											
											<path 
												fill="none" stroke="#00C2FF" 
												stroke-width="7" 
												:d="describeArc(0, probeAngle(probes, n-1), 43, 13)"
											></path>
										</svg>
									</div>
								</div>
								
								<div v-else class="lightestazure-color" v-html="getLocale('website_exhausted')"></div>
							</div>
						</div>
						
					</div>
					
					<transition name="fade">
						<div class="info-found" v-if="info_popup">
							<div class="box azure-gradient">
								<div class="medium-font uppercase align-center bold green-color">{{ getLocale('secret_found') }}</div>
								
								<div class="text row-padding">{{ getLocale('secret_found_text') }}</div>
								
								<v-button
									v-if="analysis && analysis.info"
									@clicked="startScan" 
									:text="getLocale('start_scanner')" 
									color="lightestazure" 
								/>
							</div>
						</div>
					</transition>
				</div>
			</div>
		</transition>
		
		<div class="info-scanner" :style="{height : body_height+'px'}" v-show="scan_mode">
			<svg class="info-svg" xmlns="http://www.w3.org/2000/svg" xmlns:xlink= "http://www.w3.org/1999/xlink" ref="info_svg">
				<defs>
					<clipPath id="mask">
						<circle id="mask-circle" :cx="svg_coords.x" :cy="svg_coords.y" r="80px" style="fill: #ffffff"/>
					</clipPath>
				</defs>
				<g clip-path="url(#mask)">
					<rect width="100%" height="100%" fill="rgba(0,0,0,0.5)"/>
					<image
						xmlns:xlink= "http://www.w3.org/1999/xlink" 
						:xlink:href="getImage('cache.gif')" 
						width="60px"
						height="60px"
						:x="svg_img.x+'%'"
						:y="svg_img.y"
						v-on:click="getInfoFragment"
					/>
				</g>
				
				<g :transform="'translate('+svg_coords.x+', '+svg_coords.y+')'" ref="pulse_container">
					<circle id="circle-shadow" r="80px" stroke="#0E2D3F" fill="transparent" stroke-width="3" />
					
					<path fill="none" stroke-dasharray="1 2" stroke="#0E2D3F" stroke-width="5" d="M -88 0 A 88 88 0 0 1 0 -88" />
					<path fill="none" stroke-dasharray="1 2" stroke="#0E2D3F" stroke-width="5" d="M 88 0 A 88 88 0 0 1 0 88" />
					
					<path id="top-curve" stroke="none" fill="none" stroke-width="3" d="M -95 0 A 95 95 0 0 1 0 -95" />
					<path id="bottom-curve" stroke="none" fill="none" stroke-width="3" d="M 95 0 A 95 95 0 0 1 0 95" />
					
					<circle cx="75" cy="-75" r="7px"  stroke="#0E2D3F" stroke-width="2px" class="radar"></circle>
					
					<circle v-for="pulse in pulses" class="pulse" :key="pulse"></circle>
					
					
					<text>
						<textPath alignment-baseline="top" xlink:href="#top-curve" >
							{{Math.floor(svg_coords.x)}}
						</textPath>
					</text>
					<text>
						<textPath alignment-baseline="top" xlink:href="#bottom-curve">
							{{Math.floor(svg_coords.y)}}
						</textPath>
					</text>
				</g>
				
			</svg>
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import crypto from 'crypto';
	import { commonMixin } from '../mixins/common.js';
	import VButton from '../components/VButton.vue';
	
	var height = Math.max( document.body.scrollHeight, document.body.offsetHeight, document.documentElement.clientHeight, document.documentElement.scrollHeight-10, document.documentElement.offsetHeight );
	
	export default {
		props: ['active', 'analyzer','old_analysis', 'probes'],
		mixins: [commonMixin],
		components: { VButton },
		data: function () {
			return{
				current_time : Date.now(),
				analysis: null,
				animation: 'start',
				advancing : false,
				body_height : height,
				info_popup : false,
				scan_mode : false,
				mouse : { x:0, y: 0},
				scroll : 0,
				svg_img : { x: Math.random()*95, y: Math.random()*0.95*height},
				pulse_interval : 0,
				pulse_timer : 0,
				pulse_index : 0,
				pulses : [],
			}
		},
		mounted(){		
			setInterval(function(){
				this.current_time = Date.now();
			}.bind(this), 1000);
			
			window.addEventListener('mousemove', this.updateCoords);
			window.addEventListener('scroll', this.updateScroll);
			window.addEventListener('resize', this.updateBodyHeight);
			window.addEventListener('contextmenu', this.closeScan);
		},
		computed: {
			current_energy(){
				if(this.analyzer == null) return 0;
				if(this.analyzer.last_analysis == null) return this.analyzer.energy;
				
				var difference = Math.floor(this.current_time/300000) - Math.floor(this.analyzer.last_analysis/300);
				return Math.min(this.analyzer.max_energy, this.analyzer.energy + (difference*this.analyzer.energy_regen));
			},
			svg_coords(){ 
				return {
					x : this.mouse.x,
					y : this.mouse.y + this.scroll
				}
			},
			probe_timer(){
				if(this.analysis == null) return 0;
				
				var speed_boost = 1-(this.analyzer.u3*0.05);
				var total = this.analysis.resources.reduce((a, b) => a + b, 0);
				
				return Math.floor(total*30*60 * speed_boost);
			},
			current_host(){
				var url = new URL(location.href);
				var md5 = crypto.createHash('md5');
				md5.update(url.host);
				return md5.digest('hex');
			},
			probing_this(){
				var result = false;
				
				this.probes.forEach(function(p){
					if(p.data1 == this.current_host){
						result = true;
					}
				}.bind(this));
				
				return result;
			}
		},
		created() {
			browser.runtime.onMessage.addListener( function(request, sender, sendResponse) {
				switch(request.type){
					case 'analysis_result':
						this.analysis = request.data;
					break;
				}
			}.bind(this));
			
			setInterval( this.checkPulse , 50);
		},
		methods: {
			parseTime(timestamp){
				if(timestamp < 0) timestamp = 0;
			
				let d = Math.floor((timestamp / (1000 * 60 * 60 * 24)));
				timestamp -=  d*(1000 * 60 * 60 * 24);
				let h = Math.floor((timestamp / (1000 * 60 * 60)));
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let s = Math.floor((timestamp / 1000) % 60);
				
				if(h > 0){
					return  h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M';
				}
				
				return m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
			},
			updateCoords(e){
				this.updateBodyHeight(e);
				this.scroll = window.scrollY;
			
				this.mouse.x = e.clientX;
				this.mouse.y = e.clientY;
				
				var x_distance = Math.abs(Math.floor(this.svg_coords.x-(this.svg_img.x*document.body.offsetWidth)/100));
				var y_distance = Math.abs(Math.floor(this.svg_coords.y-this.svg_img.y));
				var distance = Math.sqrt(Math.pow(x_distance, 2)+Math.pow(y_distance, 2))
				
				this.pulse_interval = Math.max(distance, 200);
			},
			updateScroll(e){
				this.scroll = window.scrollY;
			},
			updateBodyHeight(e){
				var height = Math.max( document.body.scrollHeight, document.body.offsetHeight, document.documentElement.clientHeight, document.documentElement.scrollHeight-10, document.documentElement.offsetHeight );
				this.body_height = height;
			},
			startAnalysis(){
				this.animation = 'active';
				
				if(this.analyzer.last_analysis != null){
					var energy_gain = (Math.floor(this.current_time/300000) - Math.floor(this.analyzer.last_analysis/300))*this.analyzer.energy_regen;
					this.analyzer.energy = Math.min(this.analyzer.energy+energy_gain, this.analyzer.max_energy);
				}
		
				this.analyzer.energy -= 10;
				
				this.analyzer.last_analysis = Math.floor(Date.now() / 1000);
				setTimeout(this.checkAnalysis, 1500);
				
				browser.runtime.sendMessage({
					type : 'analyze_website',
					data : { url : location.href }
				});
			},
			checkAnalysis(){
				if(this.analysis == null){
					setTimeout(this.checkAnalysis, 500);
				}else{
					this.animation = 'end';
					
					setTimeout(function(){
						this.$emit('checktutorial', 'probe');
					}.bind(this), 650);
					
					if(this.analysis.info){
						this.info_popup = true;
							
						setTimeout(function(){
							this.$emit('checktutorial', 'scanner');
						}.bind(this), 650);
					}
				}
			},
			startScan(){
				this.info_popup = false;
				this.scan_mode = true;
			},
			closeScan(e){
				if(this.scan_mode){
					e.preventDefault();
					this.scan_mode = false;
				}
			},
			getInfoFragment(){
				this.scan_mode = false;
				
				browser.runtime.sendMessage({
					type : 'get_info_fragment',
					data : { url : location.href }
				});
			},
			sendProbe(){
				if(this.probes.length < 3){
					var current_time = Math.floor(Date.now()/1000);
					
					this.probes.push({
						data1 : this.current_host,
						start : current_time,
						end : current_time + this.probe_timer
					});
					
					browser.runtime.sendMessage({
						type : 'send_probe',
						data : { url : location.href }
					});
				}
			},
			probeAngle(probes, index){
				if(probes.length < index+1) return 0;
				var percent = ((probes[index].end - this.current_time/1000)*100)/(probes[index].end - probes[index].start);
				return (100-percent)*3.6;
			},
			checkPulse(){
				this.pulse_timer+=50;
				
				if(this.pulse_timer >= this.pulse_interval){
					this.pulses.push(this.pulse_index);
					
					setTimeout(function(){
						this.pulses.shift();
					}.bind(this), 1000);
					
					this.pulse_timer = 0;
					this.pulse_index++;
				}
			},
		},
		watch: { 
			active: function(newVal, oldVal) {
				if(newVal === true){
					if(this.old_analysis != null){
						this.animation = 'end';
						this.analysis = this.old_analysis;
						
						if(this.analysis.info){
							this.info_popup = true;
						}
					}
				}
			}
		},	
	}
</script>


<style lang="scss" scoped>
	@import "../styles/variables";
	
	.website-analyzer{
		.analyzer{
			position: fixed;
			top: 0;
			left: 0;
			width: 100%;
			height: 100%;
			z-index: 2147483647;
			
			.inner{
				position: absolute;
				top: 50%;
				left: 50%;
				min-width: 200px;
				width: 600px;
				transform: translate(-50%,-50%);
				padding: 20px;
				color: white;
				border-radius: 10px;
				background: radial-gradient(ellipse at center, rgba(0,0,0,0.9) 0%, rgba(14,45,63,0.9) 100%);
				
				.loader{
					margin-top: 25px;
					overflow: hidden;
					transition: height 0.6s linear;
					height: 50px;
					
					.current-energy{
						width: 400px;
						margin-top: -5px;
						
						.energy-bar{
							position: relative;
							width: 100%;
							margin-top: 5px;
							
							
							.bar{
								position: relative;
								height: 6px;
								background-color: #4A3349;
								border: 1px solid black;
								
								.dot{
									position: absolute;
									top: 50%;
									transform: translate(-5px, -50%);
									width: 11px;
									height: 11px;
									border-radius: 50%;
									border-width: 3px;
									border-style: solid;
									transition: left 0.2s;
									
									&:before{
										box-shadow: none;
									}
								}
								
								.base{
									height: 100%;
									width: 0;
									transition: width 0.2s;
								}
							}
						}
					}
				
				}
				
				.wave{
					position: relative;
					width: 560px;
					height: 50px;
					overflow: hidden;
					transition: height 0.6s linear;
					margin-top: 10px;
					
					&.hide{
						height: 0;
					}
					
					.bar{
						position: absolute;
						bottom: 0;
						background: $lightestazure;
						width: 27px;
						height: 0;
					}
					
					&.active{
						.bar{
							animation: sound 0ms -800ms linear infinite alternate;
						}
						.bar:nth-child(1)  { animation-duration: 474ms; }
						.bar:nth-child(2)  { animation-duration: 433ms; }
						.bar:nth-child(3)  { animation-duration: 407ms; }
						.bar:nth-child(4)  { animation-duration: 458ms; }
						.bar:nth-child(5)  { animation-duration: 400ms; }
						.bar:nth-child(6)  { animation-duration: 427ms; }
						.bar:nth-child(7)  { animation-duration: 441ms; }
						.bar:nth-child(8)  { animation-duration: 419ms; }
						.bar:nth-child(9)  { animation-duration: 487ms; }
						.bar:nth-child(10) { animation-duration: 442ms; }
						.bar:nth-child(11) { animation-duration: 499ms; }
						.bar:nth-child(12) { animation-duration: 417ms; }
						.bar:nth-child(13) { animation-duration: 455ms; }
						.bar:nth-child(14) { animation-duration: 436ms; }
						.bar:nth-child(15) { animation-duration: 484ms; }
						.bar:nth-child(16) { animation-duration: 412ms; }
						.bar:nth-child(17) { animation-duration: 450ms; }
						.bar:nth-child(18) { animation-duration: 467ms; }
						.bar:nth-child(19) { animation-duration: 435ms; }
						.bar:nth-child(20) { animation-duration: 477ms; }
					}
				}
				
				.analysis{
					overflow: hidden;
					transition: height 0.6s linear;
					height: 0;
					
					&.active{
						height: 320px;
					}
									
					.graph-wrapper{
						width: 300px;
						height: 300px;
						
						.graph{		
							position: relative;
							margin-left: 20px;
							margin-top: 20px;
							
							svg{
								width: 100%;
								height: 100%;
							}
							
							.x-axis,
							.y-axis{
								position: absolute;
								top: 0;
								left: 50%;
								height: 100%;
								width: 1px;
								transform: translateX(-50%);
								background-color: $lightestazure;
								margin-top: -2px;
								
								.stat-label{
									position: absolute;
									bottom: 100%;
									transform: translateX(-50%);
									margin-left: 1px;
									text-transform: uppercase;
									
									&:last-child{
										top: 100%;
										bottom: unset;
									}
								}
								
								.bubble{
									position: absolute;
									background-color: #000E12;
									border: 2px solid $lightestazure;
									width: 22px;
									height: 22px;
									border-radius: 50%;
									text-align: center;
									line-height: 19px;
									transform: translateX(-50%);
									margin-left: 1px;
									
									&:first-child{
										top: unset !important;
									}
									&:last-child{
										bottom: unset !important;
									}
								}
							}
							.x-axis{
								transform: translateX(-50%) rotate(90deg);
								
								img{
									transform: rotate(-90deg);
								}
								.bubble{
									transform: translateX(-50%) rotate(-90deg);
								}
							}
						}
					}
					
					.probes{
						margin-top: 10px;
						margin-right: 50px;
						
						.probe{
							position: relative;
							margin-bottom: 30px;  
							width: 80px;
							height: 80px;
							border-radius: 50%;
							pointer-events: none;
							
							&:before{
								border-radius: 50%;
							}
							
							&.available{
								cursor: pointer;
								pointer-events: all;
								background: radial-gradient(ellipse at center, black 0%, #0E3930 100%);
								border: 1px solid #00FFB4;
								box-shadow: 0px 0px 3px 0px #00FFB4;
								
								&:before{
									box-shadow: inset 0px 0px 3px 0px #00FFB4;
								}
								
								.send{
									display: block;
									color: $lightestgreen;
								}
							}
							&.probing.available,
							&.disabled{
								pointer-events: none;
								opacity: 0.5;
								background: radial-gradient(ellipse at center, black 0%, #0E3930 100%);
								border: 1px solid #00FFB4;
								box-shadow: 0px 0px 3px 0px #00FFB4;
								
								&:before{
									box-shadow: inset 0px 0px 3px 0px #00FFB4;
								}
							}
							
							.timer,
							.send{
								position: absolute;
								left: 0;
								width: 100%;
								top: 50%;
								transform: translateY(-50%);
								text-align: center;
								font-size: 0.8rem;
								color: $lightestazure;
								text-transform: uppercase;
							}
							.send{
								display: none;
							}
							
							svg{
								position: absolute;
								z-index: -1;
								left: -10px;
								top: -10px;
							}
						}
					}
				}
			}
			
			.scan-wave{
				position: absolute;
				left: 0;
				width: 100%;
				height: 200px;
				background: linear-gradient(to top, $green 0%, transparent 100%);
				animation: scanner 1.5s linear infinite;
			}
		}
		
		.info-found{
		    position: absolute;
			left: 0;
			top: 0;
			width: 100%;
			height: 100%;
			background-color: rgba(0,0,0,0.5);
			
			.box{
				position: absolute;
				left: 50%;
				top: 50%;
				transform: translate(-50%, -50%);
				padding: 20px;
				border-radius: 10px;
				min-width: 320px;
				text-align: center;
			}
		}
		
		.info-scanner{
			position: absolute;
			left: 0;
			top: 0;
			width: 100%;
			z-index: 2147483647;
			
			svg{
				width: 100%;
				height: 100%;
				cursor: none;
				
				image{
					cursor: pointer;
				}
				circle{
					pointer-events: none;
				}
				text{
					transform: rotate(38deg);
					font-size: 10px;
				}
				.pulse{
					animation: pulse 1s linear infinite;
					cx: 75px;
					cy: -75px;
					r: 5px;
					stroke: #0E2D3F;
					stroke-width: 2px;
					fill: none;
				}
			}
		}
	}
	
	@keyframes sound {
		0% {
			opacity: .35;
			height: 0; 
		}
		100% {
			opacity: 1;       
			height: 50px;        
		}
	}
	
	@keyframes scanner{
		0%{
			top: calc(0% - 200px);
		}
		100%{
			top: calc(100% + 200px);
		}
	}
	
	@keyframes pulse {
		0% {
			opacity: 1;
			r: 5px; 
		}
		100% {
			opacity: 0;     
			r: 20px     
		}
	}
</style>

